#include"boxes.h"
#include"screen.h"
#include"mouse.h"
#include"showlife.h"

#include<string.h>

void scrollbar::init(int p,int b,int e,int m,int w,int *X)
{
 pos=p;
 beg=b;
 end=e;
 max=m;
 wid=w;
 x=X;
 setk();
}

scrollbar::scrollbar(int p,int b,int e,int m,int w,int *X)
{
 init(p,b,e,m,w,X);
 moved=0;
}

scrollbar::scrollbar()
{
 x=0;
 k=w=pos=beg=end=max=wid=0;
}

void scrollbar::setk()
{
 if(max<=(end-beg-2))
 {
  k=1;
  w=end-beg-1;
 }
 else
 {
  k=max/(end-beg-2);
  w=(end-beg-1)-(max-wid)/k;
 }
}

void Hscrollbar::show()
{
 scr.pix(beg,pos,17);
 scr.pix(end,pos,16);
 int i;
 for(i=0;i<*x/k;i++)
  scr.pix(i+beg+1,pos,'+');
 for(i=0;i<w;i++)
  scr.pix(i+beg+1+*x/k,pos,10);
 for(i=beg+1+*x/k+w;i<end;i++)
  scr.pix(i,pos,'+');
}

void Vscrollbar::show()
{
 scr.pix(pos,beg,30);
 scr.pix(pos,end,31);
 int i;
 for(i=0;i<*x/k;i++)
  scr.pix(pos,i+beg+1,'+');
 for(i=0;i<w;i++)
  scr.pix(pos,i+beg+1+*x/k,10);
 for(i=beg+1+*x/k+w;i<end;i++)
  scr.pix(pos,i,'+');
}

void Hscrollbar::mousemove()
{
 moved=0;
 if(ms.y==pos&&(ms.butt))
 {
  if(ms.x<end&&ms.x>beg)
  {
   (*x)=(ms.x-w/2-beg-1)*k;
  }
  else if(ms.x==beg)
  {
   (*x)--;
  }
  else if(ms.x==end)
  {
   (*x)++;
  }
  moved=1;
  if(*x>(max-wid))*x=max-wid;
  if(*x<0)*x=0;
 }
}

void Vscrollbar::mousemove()
{
 moved=0;
 if(ms.x==pos&&(ms.butt))
 {
  if(ms.y<end&&ms.y>beg)
  {
   (*x)=(ms.y-w/2-beg-1)*k;
  }
  else if(ms.y==beg)
  {
   (*x)--;
  }
  else if(ms.y==end)
  {
   (*x)++;
  }
  moved=1;
  if(*x>(max-wid))*x=max-wid;
  if(*x<0)*x=0;
 }
}

void box::setpos(int X0,int Y0,int X1,int Y1)
{
 left=X0;
 right=X1;
 top=Y0;
 bottom=Y1;
}

void box::show()
{
 if(showlf.zoom==3)
 {
  showlf.zoomin();
  showlf.show();
 }
 scr.pix(left,top,218);
 scr.pix(left,bottom,192);
 scr.pix(right,top,191);
 scr.pix(right,bottom,217);
 int i,j;
 for(i=left+1;i<right;i++)
 {
  scr.pix(i,top,196);
  scr.pix(i,bottom,196);
 }
 for(i=top+1;i<bottom;i++)
 {
  scr.pix(left,i,179);
  scr.pix(right,i,179);
 }
 for(i=top+1;i<bottom;i++)
  for(j=left+1;j<right;j++)
   scr.pix(j,i,' ');
}

int clickbox::click()
{
 if(ms.x>=left&&ms.x<=right&&ms.y>=top&&ms.y<=bottom)
  return ms.butt;
 else return 0;
}

button::button()
{
 setpos(0,0,0,0);
 settext("");
 pressed=0;
}

void button::settext(char *S)
{
 strcpy(text,S);
}

void button::press()
{
 show();
 textxy((right+left-strlen(text))/2+1,(bottom+top)/2,text);
}

void button::release()
{
 int i,j;
 for(j=top;j<=bottom;j++)
  for(i=left;i<=right;i++)
   scr.pix(i,j,219);
 textxy((right+left-strlen(text))/2+1,(bottom+top)/2,text,1);
}

int button::mousepress()
{
 int ret=0;
 if(ms.x>=left&&ms.x<=right&&ms.y>=top&&ms.y<=bottom)
 switch(ms.butt)
 {
  case 0:
   if(pressed)
   {
    ms.off();
    release();
    ms.on();
   }
   pressed=0;
   ret=0;
  break;
  case 1:case 2:case 4:
   ms.off();
   press();
   ms.on();
  case 9:case 10:case 12:
   pressed=1;
   ret=1;
  break;
 }
 return ret;
}

titlebox::titlebox()
{
 setpos(0,0,0,0);
 settitle("");
}

void titlebox::settitle(char* S)
{
 strcpy(title,S);
}

void titlebox::show()
{
 box::show();
 textxy((left+right-strlen(title))/2+1,top+1,title);
 scr.pix(left,top+2,195);
 scr.pix(right,top+2,180);
 int i;
 for(i=left+1;i<right;i++)
  scr.pix(i,top+2,196);
}

radiobutton::radiobutton()
{
 checked=0;
 settext("");
 setpos(0,0);
}

void radiobutton::settext(const char* str)
{
 strcpy(text,str);
}

void radiobutton::show()
{
 char tmp[20]="";
 tmp[0]='(';
 if(checked)
  tmp[1]=7;
 else tmp[1]=' ';
 tmp[2]=')';
 tmp[3]=' ';
 strcat(tmp+4,text);
 scr.textxy(x,y,tmp);
}

int radiobutton::click()
{
 return ((ms.butt==1||ms.butt==2)&&ms.y==y&&ms.x>=x&&ms.x<(strlen(text)+4+x));
}