#include"clip.h"
#include"makelife.h"
#include"showlife.h"
#include"help.h"

clipboard clip;

buffer::buffer()
{
 ptr=0;
 Xsize=Ysize=x=y=0;
}

buffer::~buffer()
{
 if(ptr)delete[] ptr;
}

int buffer::alloc(int X,int Y)
{
 if(X<=0||Y<=0)return 0;
 if(ptr)delete[] ptr;
 ptr=new unsigned char[X*Y];
 if(ptr)
 {
  Xsize=X;
  Ysize=Y;
  return 1;
 }
 else
 {
  Xsize=0;
  Ysize=0;
  help.showmessage("No enough memory for clipboard operation");
  return 0;
 }
}

unsigned char& buffer::operator()(int X,int Y)
{
 if(X>=0&&X<Xsize&&Y>=0&&Y<Ysize)
  return ptr[X+Y*Xsize];
 else
  return ptr[0];
}

clipboard::clipboard()
{
 on=top=bottom=left=right=0;
}

void clipboard::cut()
{
 copy();
 on=1;
 del();
}

void clipboard::copy()
{
 int i,j;
 if(!on)return;
 if(clp.alloc(right-left+1,bottom-top+1))
 {
  clp.x=left;
  clp.y=top;
  for(j=0;j<clp.maxY();j++)
   for(i=0;i<clp.maxX();i++)
    clp(i,j)=life(i+left,j+top);
 }
 on=0;
}

void clipboard::paste(int X,int Y)
{
 int i,j;
 on=0;
 if(old.alloc(clp.maxX(),clp.maxY()))
 {
  old.x=X;
  old.y=Y;
  for(j=0;j<old.maxY();j++)
   for(i=0;i<old.maxX();i++)
    old(i,j)=life((i+X+life.maxX())%life.maxX(),(j+Y+life.maxY())%life.maxY());
 }
 for(j=0;j<clp.maxY();j++)
  for(i=0;i<clp.maxX();i++)
   life((i+X+life.maxX())%life.maxX(),(j+Y+life.maxY())%life.maxY())=clp(i,j);
}

void clipboard::del()
{
 int i,j;
 if(!on)return;
 if(old.alloc(right-left+1,bottom-top+1))
 {
  old.x=left;
  old.y=top;
  for(j=0;j<old.maxY();j++)
   for(i=0;i<old.maxX();i++)
    old(i,j)=life(i+left,j+top);
  for(j=0;j<old.maxY();j++)
   for(i=0;i<old.maxX();i++)
    life(i+left,j+top)=0;
 }
 on=0;
}

void clipboard::selall()
{
 on=1;
 top=left=0;
 bottom=life.maxY()-1;
 right=life.maxX()-1;
}

void clipboard::undo()
{
 int i,j;
 on=0;
 for(j=0;j<old.maxY();j++)
  for(i=0;i<old.maxX();i++)
   life((i+old.x+life.maxX())%life.maxX(),(j+old.y+life.maxY())%life.maxY())=old(i,j);
}

void clipboard::point1(int x,int y)
{
 on=1;
 y0=top=bottom=y;
 x0=left=right=x;
}

void clipboard::point2(int x,int y)
{
 if(x<x0)
 {
  right=x0;
  left=x;
 }
 else
 {
  left=x0;
  right=x;
 }
 if(y<y0)
 {
  bottom=y0;
  top=y;
 }
 else
 {
  bottom=y;
  top=y0;
 }
 align();
}

void clipboard::align()
{
 top-=top%showlf.zoom;
 left-=left%showlf.zoom;
 right+=showlf.zoom-1-right%showlf.zoom;
 bottom+=showlf.zoom-1-bottom%showlf.zoom;
}
