#ifndef FILEWORKH
#define FILEWORKH

#include"boxes.h"
#include"help.h"

struct listitem// ᯨ᪠
{
 private:
 listitem *next;
 friend list;
 public:
 char name[16];
};

class list//c᮪
{
 private:
  listitem *begin,*cur;
  int N;//᫮ ⮢
 public:
  list();
  int next();// ᫥騩 
  void reset();//⠭  砫
  const char* get();// 
  void insert(const char*);//⠢ 
  void destroy();// ᯨ᮪
  int num(){return N;};
  ~list();
};

class showlist
{
 protected:
  list lst;
  int x,y;
  int height,width;
  int pos;
  int selection;
  void limits();
 public:
  showlist();
  void setpos(int X,int Y) {x=X;y=Y;}
  void setheight(int h) {height=h;}
  void select(int);
  void movedown(int step=1);
  void moveup(int step=1);
  void pgup() {moveup(height);}
  void pgdn() {movedown(height);}
  const char* getsel();
  void show();
};

class drivelist:public showlist
{
 public:
  drivelist();
  void activate();
  void selectdrive(char);
};

class filelist:public showlist
{
 private:
  Vscrollbar scroll;
  char* lowcase(char*);
 public:
  filelist();
  void reread();
  void show();
  int mousescroll();
  void search(const char*);
};

enum filetype {flife,ftext,fbmp,fany};

class nameenter:public box
{
 private:
  int curpos;
  filetype type;
  int isfile(char);
  int isfile(const char*);
  char filename[16];
  void poscur();
 public:
  int cursor;
  int changed;
  nameenter();
  void setname(const char*);
  const char* getname() {return filename;}
  void settype(filetype T);
  filetype gettype(){return type;}
  void show();
  void init();
  void mouseactivate();
  int key(int,int b=0);
};

class showtype:public clickbox
{
 public:
  showtype();
  void show(filetype,int,int);
  int click();
};

class showpos:public clickbox
{
 private:
  int Xsize,Ysize;
 public:
  int dx,dy;
  showpos();
  void show();
  void setsize(int X,int Y) {Xsize=X; Ysize=Y;}
  int click();
  void key();
};

enum dialtype {dopen,dsave};

class filework:public titlebox
{
 private:
  friend void main(int,char**);
  friend helpboxes;
  filelist files;
  drivelist drives;
  char path[512];
  button action;
  button fieldsize;
  nameenter fname;
  showtype ftype;
  showpos fpos;
  dialtype type;
  void showall();
  void getpath();
  void showpath();
  void showinfo();
  void changetype();
  void commonmouse();
  void commonkey(int,int);
  void savenow();
  void loadnow();
  void lifeinfo(int&,int&);
  void bmpinfo(int&,int&);
  void textinfo(int&,int&);
  void lifeload();
  void bmpload();
  void textload();
  void lifesave();
  void bmpsave();
  void textsave();
  int exitdialog;
 public:
  filework();
  void save();
  void saveas();
  void open();
};

extern filework file;

#endif