#include"filework.h"
#include"help.h"
#include"makelife.h"

#include<stdio.h>
#include<string.h>
#include<sys\stat.h>
#include<stdlib.h>
#include<ctype.h>

struct BITMAPFILEHEADER// 䠩 BMP
{
short	Type;		//⨯ 䠩 ( ⮢ ࠧ - BM)
long	Size;		//ࠧ 䠩  long
short	Reserved1;	// ᯮ
short	Reserved2;	// ᯮ
long	Offbits;	//ᬥ饭  ⮢ ࠧ 
} BMPheader;

struct BITMAPINFOHEADER// ࠦ
{
long	Size;		//᫮ ,  ன
			//BITMAPINFOHEADER
long	Width;	//ਭ ⮢ ࠧ  ᥫ
long	Height;	// ⮢ ࠧ  ᥫ
short	Planes;	//᫮ ⮢ ᪮⥩ ன⢠
short	BitCount;	//᫮ ⮢  ᥫ
long	Compression;	//⨯ ᦠ
long	SizeImage;	//ࠧ ⨭  
long	XPelsPerMeter;//ਧ⠫쭮 ࠧ襭 ன⢠,
			//ᥫ/
long	YPelPerMeter;	//⨪쭮 ࠧ襭 ன⢠,
			//ᥫ/
long	ClrUsed;	//᫮ ᯮ㥬 梥⮢
long	ClrImportant; //᫮ "" 梥⮢
} Header;

struct RGBQUAD
{// 
char	Red;		//⥭ᨢ ᭮
char	Green;	//⥭ᨢ 
char	Blue;	//⥭ᨢ 㡮
char	Reserved;	// ᯮ
} RGB;


void filework::lifeinfo(int& x,int &y)
{
 FILE* F;
 F=fopen(fname.getname(),"rb");
 if(!F)
 {
  x=y=0;
  return;
 }
 char logo[8];
 struct stat st;
 stat(fname.getname(),&st);
 y=st.st_size;
 fread(logo,7,1,F);
 logo[7]=0;
 if(!strcmp(logo,"life1.0"))// ଠ
 {
  fread(&x,2,1,F);
  y-=9;
 }
 else// ଠ
 {
  x=20;
 }
 y/=x;
 x*=8;
 fclose(F);
}

void filework::bmpinfo(int& x,int &y)
{
 FILE* F;
 F=fopen(fname.getname(),"rb");
 if(!F)
 {
  x=y=0;
  return;
 }
 fread(&BMPheader,sizeof(BMPheader),1,F);
 fread(&Header,sizeof(Header),1,F);
 x=Header.Width;
 y=Header.Height;
 int length=Header.Width/8*Header.BitCount;
 if(length%4) length+=4-length%4;
 if(BMPheader.Size!=(sizeof(BMPheader)+sizeof(Header)+(1<<Header.BitCount)*sizeof(RGBQUAD)+Header.Height*length))
  y=0;
 fclose(F);
}

void filework::textinfo(int& x,int &y)
{
 FILE* F;
 F=fopen(fname.getname(),"rt");
 char str[256];
 fgets(str,240,F);
 x=strlen(str);
 y=0;
 fclose(F);
}

void filework::lifeload()
{
 int i,j,k;
 char mask;
 int x,y;
 int dx=fpos.dx*life.maxX()/6;
 int dy=fpos.dy*life.maxY()/6;
 FILE* F;
 F=fopen(fname.getname(),"rb");
 if(!F)
 {
  life.kill();
  exitdialog=1;
  //help.showmessage("Can't open specified file");
  //showall();
  return;
 }
 char logo[8];
 struct stat st;
 stat(fname.getname(),&st);
 y=st.st_size;
 fread(logo,7,1,F);
 logo[7]=0;
 if(!strcmp(logo,"life1.0"))// ଠ
 {
  fread(&x,2,1,F);
  y-=9;
 }
 else// ଠ
 {
  x=20;
  rewind(F);
 }
 y/=x;
 char* ptr;
 ptr=new char[x*y];
 if(!ptr)
 {
  help.showmessage("No enough memory to load life");
  showall();
  return;
 }
 fread(ptr,x*y,1,F);
 for(i=0;i<y;i++)
 {
  if((i+dy)>=life.maxY())break;
  for(j=0;j<x;j++)
  {
   mask=0x80;
   for(k=0;k<8;k++)
   {
    if((j*8+k+dx)>=life.maxX())break;
    if(ptr[j+i*x]&mask) life(j*8+k+dx,i+dy)=1;
    else life(j*8+k+dx,i+dy)=0;
    mask>>=1;
   }
  }
 }
 delete[] ptr;
 fclose(F);
 exitdialog=1;
}

void filework::bmpload()
{
 int i,j,n,k;
 unsigned long L;
 unsigned char* str=0,* col=0;
 FILE* F;
 F=fopen(fname.getname(),"rb");
 if(!F)
 {
  life.kill();
  exitdialog=1;
  return;
 }
 fread(&BMPheader,sizeof(BMPheader),1,F);
 fread(&Header,sizeof(Header),1,F);
 int length=Header.Width/8*Header.BitCount;
 if(length%4) length+=4-length%4;
 if(BMPheader.Size!=(sizeof(BMPheader)+sizeof(Header)+(1<<Header.BitCount)*sizeof(RGBQUAD)+Header.Height*length))
 {
  help.showmessage("Can't open, unsupported bitmap format");
  showall();
  return;
 }
 str=new unsigned char[length];
 //str=(unsigned char*)malloc(length);
 if(!str)
 {
  help.showmessage("No enough memory to load bitmap");
  showall();
  return;
 }
 if(Header.BitCount!=24)
 {
  col=new unsigned char[1<<Header.BitCount];
  if(!col)
  {
   help.showmessage("No enough memory to load bitmap");
   showall();
   return;
  }
  for(i=0;i<(1<<Header.BitCount);i++)
  {
   L=0;
   fread(&RGB,sizeof(RGB),1,F);
   L+=RGB.Red+RGB.Green+RGB.Blue;
   L/=3;
   if(L>127) col[i]=1;
   else col[i]=0;
  }
 }
 n=Header.Height-life.maxY();
 if(n>0)
 {
  for(i=0;i<n;i++)
   fread(str,length,1,F);
  n=0;
 }
 else n=-n;
 unsigned char mask;
 for(i=life.maxY()-n-1;i>=0;i--)
 {
  fread(str,length,1,F);
  switch(Header.BitCount)
  {
   case 1:
   for(j=0;j<length;j++)
   {
    mask=0x80;
    for(k=0;k<8;k++)
    {
     if((j*8+k)>=life.maxX())break;
     if(str[j]&mask) life(j*8+k,i)=col[1];
     else life(j*8+k,i)=col[0];
     mask>>=1;
    }
   }
   break;
   case 2:
   for(j=0;j<length;j++)
   {
    mask=0xC0;
    for(k=0;k<4;k++)
    {
     if((j*4+k*2)>=life.maxX())break;
     life(j*4+k*2,i)=col[(str[j]&mask)>>(6-k*2)];
     mask>>=2;
    }
   }
   break;
   case 4:
   for(j=0;j<length;j++)
   {
    mask=0xF0;
    for(k=0;k<2;k++)
    {
     if((j*2+k*4)>=life.maxX())break;
     life(j*2+k*4,i)=col[(str[j]&mask)>>(4-k*4)];
     mask>>=4;
    }
   }
   break;
   case 8:
   for(j=0;j<length;j++)
   {
    if((j)>=life.maxX())break;
    life(j,i)=col[str[j]];
   }
   break;
   case 24:
   for(j=0;j<length;j+=3)
   {
    if((j/3)>=life.maxX())break;
    L=0;
    L+=str[j]+str[j+1]+str[j+2];
    L/=3;
    if(L>127) life(j/3,i)=1;
    else life(j/3,i)=0;
   }
   break;
  }
 }
 delete[] col;
 delete[] str;
 //free(str);
 fclose(F);
 exitdialog=1;
}

void filework::textload()
{
 int i,j,k,x;
 FILE* F;
 F=fopen(fname.getname(),"rt");
 if(!F)
 {
  life.kill();
  exitdialog=1;
  return;
 }
 char str[256];
 for(i=0;i<life.maxY();i++)
 {
  if(feof(F))break;
  fgets(str,255,F);
  for(j=0,x=0;x<life.maxX()&&j<strlen(str);j++,x++)
  {
   if(str[j]=='\n')break;
   if(str[j]=='\t')
   {
    for(k=0;k<8;k++)
     if((x+k)<life.maxX()) life(x+k,i)=0;
    x+=7;
   }
   else
   {
    if(!isspace(str[j])) life(x,i)=1;
    else life(x,i)=0;
   }
  }
 }
 fclose(F);
 exitdialog=1;
}

void filework::lifesave()
{
 int i,j,k,x,y;
 char mask;
 FILE* F;
 F=fopen(fname.getname(),"wb");
 if(!F)
 {
  help.showmessage("Can't create specified file");
  showall();
  return;
 }
 x=life.maxX()/8;
 char logo[8]="life1.0";
 fwrite(logo,7,1,F);
 fwrite(&x,2,1,F);
 char* ptr;
 int savetype=0;
 ptr=new char[x*life.maxY()];
 if(!ptr)
 {
  ptr=new char[x];
  savetype=1;
  if(!ptr)
  {
   help.showmessage("No enough memory to save life");
   showall();
   return;
  }
 }
 for(i=0;i<life.maxY();i++)
 {
  y=i;
  for(j=0;j<x;j++)
  {
   mask=0x80;
   if(savetype)y=0;
   ptr[j+y*x]=0;
   for(k=0;k<8;k++)
   {
    if(life(j*8+k,i)) ptr[j+y*x]|=mask;
    mask>>=1;
   }
  }
  if(savetype) fwrite(ptr,x,1,F);
 }
 if(!savetype) fwrite(ptr,x*life.maxY(),1,F);
 delete[] ptr;
 fclose(F);
 exitdialog=1;
}

void filework::bmpsave()
{
 FILE* F;
 int X=life.maxX()/8;
 if(X%4) X+=4-X%4;
 F=fopen(fname.getname(),"wb");
 if(!F)
 {
  help.showmessage("Can't create specified file");
  showall();
  return;
 }
 BMPheader.Type='B'+('M'<<8);
 BMPheader.Size=sizeof(BMPheader)+sizeof(Header)+2*sizeof(RGB)+life.maxY()*X;
 BMPheader.Reserved1=BMPheader.Reserved2=0;
 BMPheader.Offbits=sizeof(BMPheader)+sizeof(Header)+2*sizeof(RGB);
 Header.Size=sizeof(Header);
 Header.Width=life.maxX();
 Header.Height=life.maxY();
 Header.Planes=1;
 Header.BitCount=1;
 Header.Compression=0;
 Header.SizeImage=life.maxY()*X;
 Header.XPelsPerMeter=Header.YPelPerMeter=0;
 Header.ClrUsed=2;
 Header.ClrImportant=2;
 fwrite(&BMPheader,sizeof(BMPheader),1,F);
 fwrite(&Header,sizeof(Header),1,F);
 RGB.Red=0;
 RGB.Green=0;
 RGB.Blue=0;
 RGB.Reserved=0;
 fwrite(&RGB,sizeof(RGB),1,F);
 RGB.Red=255;
 RGB.Green=255;
 RGB.Blue=255;
 fwrite(&RGB,sizeof(RGB),1,F);
 int i,j,k;
 unsigned char* ptr;
 unsigned char mask;
 ptr=new unsigned char[X];
 for(i=life.maxY()-1;i>=0;i--)
 {
  for(j=0;j<X;j++)
  {
   mask=0x80;
   ptr[j]=0;
   for(k=0;k<8;k++)
   {
    if((j*8+k)>=life.maxX()) break;
    if(life(j*8+k,i)) ptr[j]|=mask;
    mask>>=1;
   }
  }
  fwrite(ptr,X,1,F);
 }
 delete[] ptr;
 exitdialog=1;
}

void filework::textsave()
{
 FILE* F;
 F=fopen(fname.getname(),"wt");
 if(!F)
 {
  help.showmessage("Can't create specified file");
  showall();
  return;
 }
 int i,j;
 char str[256];
 for(i=0;i<life.maxY();i++)
 {
  for(j=0;j<life.maxX();j++)
  {
   if(life(j,i))str[j]='X';
   else str[j]=' ';
  }
  str[life.maxX()]=0;
  fputs(str,F);
  putc('\n',F);
 }
 fclose(F);
 exitdialog=1;
}

