#include"life.h"

extern int kx,ky,selx,sely;
extern life lf;


clipboard::clipboard()
{
 clp=0;
 old=0;
 oldx=oldy=0;
 olddx=olddy=dx=dy=0;
}

clipboard::~clipboard()
{
 if(clp) delete[] clp;
 if(old) delete[] old;
 /*if(clp) free(clp);
 if(old) free(old);*/
}

void clipboard::cut()
{
 copy();
 del();
}

void clipboard::copy()
{
 int i,j;
 int x=kx<selx?kx:selx;
 int y=ky<sely?ky:sely;
 int Dx=abs(kx-selx)+1;
 int Dy=abs(ky-sely)+1;
 if((Dx>1||Dy>1)&&newmem(clp,Dx,Dy))
 {
  dx=Dx;
  dy=Dy;
  for(i=0;i<dy;i++)
   for(j=0;j<dx;j++)
    clp[j+i*dx]=lf.areal[(i+y+100)%100][(j+x+160)%160];
 }
}

void clipboard::paste()
{
 int i,j;
 if(newmem(old,dx,dy))
 {
  oldx=kx;
  oldy=ky;
  olddx=dx;
  olddy=dy;
  for(i=0;i<dy;i++)
   for(j=0;j<dx;j++)
    old[j+i*dx]=lf.areal[(i+ky+100)%100][(j+kx+160)%160];
 }
 if(clp)
 {
  for(i=0;i<dy;i++)
   for(j=0;j<dx;j++)
    lf.areal[(i+ky+100)%100][(j+kx+160)%160]=clp[j+i*dx];
 }
 lf.print();
}

void clipboard::del()
{
 int i,j;
 int Dx=abs(kx-selx)+1;
 int Dy=abs(ky-sely)+1;
 if((Dx>1||Dy>1)&&newmem(old,Dx,Dy))
 {
  oldx=kx<selx?kx:selx;
  oldy=ky<sely?ky:sely;
  olddx=Dx;
  olddy=Dy;
  for(i=0;i<olddy;i++)
   for(j=0;j<olddx;j++)
    old[j+i*olddx]=lf.areal[(i+oldy+100)%100][(j+oldx+160)%160];
  for(i=0;i<olddy;i++)
   for(j=0;j<olddx;j++)
    lf.areal[(i+oldy+100)%100][(j+oldx+160)%160]=0;
 }
 lf.print();
}

void clipboard::selall()
{
 kx=0;
 ky=0;
 selx=159;
 sely=99;
 lf.print();
}

void clipboard::undo()
{
 int i,j;
 for(i=0;i<olddy;i++)
   for(j=0;j<olddx;j++)
    lf.areal[(i+oldy+100)%100][(j+oldx+160)%160]=old[j+i*olddx];
 lf.print();
}

int clipboard::newmem(char*&p,int x,int y)
{
 if(p)delete[] p;
 p=0;
 p=new char[x*y];
 if(!p)
 {
  sound(400);
  delay(100);
  nosound();
 }
 if(p)return 1;
 else return 0;
}

/*int clipboard::newmem(char*&p,int x,int y)
{
 if(p)free(p);
 p=0;
 p=(char*)malloc(x*y);
 if(!p)
 {
  sound(400);
  delay(100);
  nosound();
 }
 if(p)return 1;
 else return 0;
} */